/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.30 by edhill, Fri Dec 5 17:46:32 2003 UTC revision 1.40 by edhill, Tue Jul 6 19:53:34 2004 UTC
# Line 32  usage() Line 32  usage()
32      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
33      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
34      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
35        echo "  (-deldir|-dd)            on success, delete the output directory"
36      echo      echo
37      echo "and where STRING follows a whitespace-delimited format"      echo "and where STRING follows a whitespace-delimited format"
38      echo "such as:"      echo "such as:"
# Line 44  usage() Line 45  usage()
45  #  build the mpack utility  #  build the mpack utility
46  build_mpack()  build_mpack()
47  {  {
48      echo -n "building the mpack utility...  "      printf "building the mpack utility...  "
49      if test ! -x "$MPACKDIR/mpack" ; then      if test ! -x "$MPACKDIR/mpack" ; then
50          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
51              echo              echo
# Line 54  build_mpack() Line 55  build_mpack()
55              echo              echo
56              HAVE_MPACK=f              HAVE_MPACK=f
57          fi          fi
58          echo -n "building mpack...  "          printf "building mpack...  "
59          if test "x$CC" = x ; then          if test "x$CC" = x ; then
60              export CC=cc              export CC=cc
61          fi          fi
# Line 77  build_mpack() Line 78  build_mpack()
78    
79  testoutput_for_prop()  testoutput_for_prop()
80  {  {
81      # testoutput_for_prop dir s1 label subdir      # testoutput_for_prop dir s1 label subdir extension
82      #      #
83      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt
84      #  using search strings s1 and text label      #  using search strings s1 and text label
# Line 99  testoutput_for_prop() Line 100  testoutput_for_prop()
100          return 99          return 99
101      fi      fi
102      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
103          echo testoutput_for_prop: grep "$2" $1/results/output.txt 1>&2          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2
104      fi      fi
105      grep "$2" $1/results/output.txt | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt
106      lncnt=`wc -l tmp2.txt | awk '{print $1}' `      lncnt=`wc -l tmp2.txt | awk '{print $1}' `
107      if [ $lncnt -lt 3 ]; then      if [ $lncnt -lt 3 ]; then
108          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
# Line 171  testoutput_ad() Line 172  testoutput_ad()
172    
173  testoutput()  testoutput()
174  {  {
175      # testoutput directory subdir      # testoutput directory subdir extension
176      #      #
177      #  test output in "directory"      #  test output in "directory"
178      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
179          if [ $debug -gt 0 ]; then          if [ $debug -gt 0 ]; then
180              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2
181          fi          fi
182          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2; cg2dres=$?          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?
183          if [ $debug -gt 0 ]; then          if [ $debug -gt 0 ]; then
184              echo testoutput: cg2dres=$cg2dres 1>&2              echo testoutput: cg2dres=$cg2dres 1>&2
185          fi          fi
186          testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2; tmin=$?          testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?
187          testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2; tmax=$?          testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?
188          testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2; tmean=$?          testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?
189          testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2; tsd=$?          testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?
190          testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2; smin=$?          testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?
191          testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2; smax=$?          testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?
192          testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2; smean=$?          testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?
193          testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2; ssd=$?          testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?
194          testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2; umin=$?          testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?
195          testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2; umax=$?          testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?
196          testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2; umean=$?          testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?
197          testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2; usd=$?          testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?
198          testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2; vmin=$?          testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?
199          testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2; vmax=$?          testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?
200          testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2; vmean=$?          testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?
201          testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2; vsd=$?          testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?
202          dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \          dashnum $cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd \
203              $umin $umax $umean $usd $vmin $vmax $vmean $vsd              $umin $umax $umean $usd $vmin $vmax $vmean $vsd
204      else      else
# Line 211  genmakemodel() Line 212  genmakemodel()
212      if test "x$NOGENMAKE" = xt ; then      if test "x$NOGENMAKE" = xt ; then
213          echo "genmake skipped!"          echo "genmake skipped!"
214      else      else
215          GENMAKE2="$BASH ../../../tools/genmake2"          if test "x$BASH" = x ; then
216                GENMAKE2="../../../tools/genmake2"
217            else
218                GENMAKE2="$BASH ../../../tools/genmake2 -bash $BASH"
219            fi
220          (          (
221              cd $1;              cd $1;
222              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
# Line 409  runmodel() Line 414  runmodel()
414          cd $1          cd $1
415          printf 'runmodel ... ' 1>&2          printf 'runmodel ... ' 1>&2
416          # make output.txt          # make output.txt
417          $COMMAND >> run.log 2>&1          echo
418            # echo "COMMAND='$COMMAND'"
419            # echo "pwd='"`pwd`"'"
420            ( eval $COMMAND ) >> run.log 2>&1
421          RETVAL=$?          RETVAL=$?
422          if test "x$RETVAL" = x0 ; then          if test "x$RETVAL" = x0 ; then
423              echo successful 1>&2              echo successful 1>&2
# Line 432  createcodelet() Line 440  createcodelet()
440  {  {
441      # create codelet for comparing model output      # create codelet for comparing model output
442    
443      echo -n "creating the comparison code...  "      printf "creating the comparison code...  "
444      cat > tmp_cmpnum.c <<EOF      cat > tmp_cmpnum.c <<EOF
445  #include <stdio.h>  #include <stdio.h>
446  #include <math.h>  #include <math.h>
447  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
448    int linnum,best;    int linnum,best,lncnt;
449    double a,b,diff;    double a,b,diff;
450    best = -16;    best = -16;
451    while( 1 )  {    lncnt = 0;
452      while( 1 & (lncnt+=1) < 999 )  {
453      scanf("%d", &linnum);      scanf("%d", &linnum);
454      if (linnum == -1)  break;      if (linnum == -1)  break;
455      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
# Line 456  int main( int argc, char** argv )  { Line 465  int main( int argc, char** argv )  {
465        }        }
466      }      }
467    }    }
468      if (lncnt == 999) best=-29;
469    printf("%d\n", -best);    printf("%d\n", -best);
470    return 0;    return 0;
471  }  }
# Line 536  clean=0 Line 546  clean=0
546  expts=''  expts=''
547  # ieee=1  # ieee=1
548    
549  IEEE=  IEEE=true
550  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
551      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
552  fi  fi
# Line 558  MPACK="$MPACKDIR/mpack" Line 568  MPACK="$MPACKDIR/mpack"
568  COMMAND=  COMMAND=
569  MAKE=make  MAKE=make
570  MPI=f  MPI=f
571    DELDIR=
572    
573  ADM=  ADM=
574    
575  echo -n "parsing options...  "  printf "parsing options...  "
576    
577  ac_prev=  ac_prev=
578  for ac_option ; do  for ac_option ; do
# Line 633  for ac_option ; do Line 644  for ac_option ; do
644          -debug) debug=1 ;;          -debug) debug=1 ;;
645          -quiet) verbose=0 ;;          -quiet) verbose=0 ;;
646    
647            -deldir | -dd) DELDIR=t ;;
648    
649          -*)          -*)
650              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
651              usage              usage
# Line 675  echo "OK" Line 688  echo "OK"
688  createcodelet  createcodelet
689    
690  #  build the mpack utility  #  build the mpack utility
691  build_mpack  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
692        echo "skipping mpack build"
693    else
694        build_mpack
695    fi
696    
697  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
698  MACH=`hostname`  MACH=`hostname`
# Line 695  if test "x$RETVAL" != x0 ; then Line 712  if test "x$RETVAL" != x0 ; then
712      exit 1      exit 1
713  fi  fi
714  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
715  echo -n "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
716  start_date=`date`  start_date=`date`
717  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
718    
# Line 784  for dir in $TESTDIRS ; do Line 801  for dir in $TESTDIRS ; do
801          linkdata $use_seperate_build $dir/$rundir          linkdata $use_seperate_build $dir/$rundir
802      fi      fi
803            
804        #  Check whether there are "extra runs" for this testdir
805        extra_runs=
806        if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then
807            ex_run_dirs=`( cd $dir ; echo input.* )`
808            echo "ex_run_dirs='$ex_run_dirs'"
809            for exd in $ex_run_dirs ; do
810                name=`echo $exd | sed -e 's/input.//g'`
811                outf="$dir/results/output.txt.$name"
812                if test -f $outf -a -r $outf ; then
813                    extra_runs="$extra_runs $name"
814                fi
815            done
816        fi
817    
818      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
819          code_dir=code          code_dir=code
820          CODE_DIR=$dir/code          CODE_DIR=$dir/code
# Line 826  for dir in $TESTDIRS ; do Line 857  for dir in $TESTDIRS ; do
857      echo      echo
858      if test "x$ADM" = x ; then      if test "x$ADM" = x ; then
859          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
860            echo
861            echo "$fres" >> $SUMMARY
862            echo "fresults='$fres'" > $CDIR"/summary.txt"
863            echo "MACH='$MACH'" >> $CDIR"/summary.txt"
864            echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
865            echo "DATE='$DATE'" >> $CDIR"/summary.txt"
866            echo "tdir='$dir'" >> $CDIR"/summary.txt"
867    
868            OLD_COMMAND=$COMMAND
869            COMMAND="./mitgcmuv > output.txt"
870            for ex in $extra_runs ; do
871                test -e "$dir/tr_run" && rm -rf "$dir/tr_run"
872                mkdir "$dir/tr_run"
873                links=`( cd "$dir/input" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
874                (
875                    cd "$dir/tr_run"
876                    for i in $links; do
877                        ln -s ../input/$i $i
878                    done
879                )
880                links=`( cd "$dir/input.$ex" > /dev/null 2>&1 ; ls -1 | grep -v CVS )`
881                (
882                    cd "$dir/tr_run"
883                    for i in $links; do
884                        test -e $i  &&  rm -f $i
885                        ln -s ../input.$ex/$i $i
886                    done
887                    ln -s ../$builddir/mitgcmuv mitgcmuv
888                )
889                runmodel $dir/tr_run && run=Y \
890                    && results=`testoutput $dir tr_run "."$ex`
891                fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
892                fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
893                fres="$fres.$ex"
894                echo
895                echo "$fres" >> $SUMMARY
896                echo "fresults='$fres'" > $CDIR"/summary.txt"
897                echo "MACH='$MACH'" >> $CDIR"/summary.txt"
898                echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
899                echo "DATE='$DATE'" >> $CDIR"/summary.txt"
900                echo "tdir='$dir'" >> $CDIR"/summary.txt"
901            done
902            COMMAND=$OLD_COMMAND
903      else      else
904          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`          fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`
905          fres=$fres"$results   $dir"          fres=$fres"$results   $dir"
906            echo
907            echo "$fres" >> $SUMMARY
908            echo "fresults='$fres'" > $CDIR"/summary.txt"
909            echo "MACH='$MACH'" >> $CDIR"/summary.txt"
910            echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
911            echo "DATE='$DATE'" >> $CDIR"/summary.txt"
912            echo "tdir='$dir'" >> $CDIR"/summary.txt"
913      fi      fi
     echo  
     echo "$fres" >> $SUMMARY  
     echo "fresults='$fres'" > $CDIR"/summary.txt"  
     echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
     echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
     echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
     echo "tdir='$dir'" >> $CDIR"/summary.txt"  
914            
915      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
916            
917  done  done
918    
919  echo -n "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
920  echo $start_date >> $SUMMARY  echo $start_date >> $SUMMARY
921  echo -n "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
922  date >> $SUMMARY  date >> $SUMMARY
923    
924  #  If addresses were supplied and mpack built successfully, then try  #  If addresses were supplied and mpack built successfully, then try
# Line 885  if test "x$CLEANUP" != xt ; then Line 959  if test "x$CLEANUP" != xt ; then
959      cat $SUMMARY > tr_out.txt      cat $SUMMARY > tr_out.txt
960  fi  fi
961    
962    if test "x$DELDIR" = xt ; then
963        rm -rf $DRESULTS
964    fi
965    

Legend:
Removed from v.1.30  
changed lines
  Added in v.1.40

  ViewVC Help
Powered by ViewVC 1.1.22